C  Modified simplex method for phase1
C  File:  simplex1.fcm		header:  simplex1.h

C  Tableau:
C
C	LHS  |  Const.  X(v(1))	X(v(2))	. . .	X(v(N))
C    --------+--------------------------------------------
C    Objctv  |	A(0,0)	A(0,1)	A(0,2)	. . .	A(0,N)
C    X(u(1)) |	A(1,0)	A(1,1)	A(1,2)	. . .	A(1,N)
C    X(u(2)) |	A(2,0)	A(2,1)	A(2,2)	. . .	A(2,N)
C       :    |     :       :       :               :
C       :    |     :       :       :               :
C    X(u(M)) |	A(M,0)	A(M,1)	A(M,2)	. . .	A(M,N)
C
C  Permits negative constants in constraints, representing infeasibilities.
C  Assumes objective includes -(sum of infeasibilities).
C
C  Each row is read as
C
C	LHS = A(i,0) + A(i,1)*X(v(1)) + A(i,2)*X(v(2)) +...+ A(i,N)*X(v(N))


C  Attempt maximization of the objective.  Leaves updated tableau in
C  A, U, V.  Outcome is reported in Iout as
C
C	Iout = 0	Maximal solution found
C	Iout = 1	Feasible region is unbounded
C	Iout = 2	Failed due to unmanageable degeneracy
C
C  Icyc reports number of cycles.

      INTERFACE
      subroutine simplex1(M, N, A, U, V, Iout, Icyc)
      integer M, N, Iout, Icyc
      real,    array(0:M,0:N) :: A
      integer, array(0:M)     :: U
      integer, array(0:N)     :: V
CMF$  LAYOUT A(,), U(), V()
      END INTERFACE
